## antimicro 2.23

=== CMakeLists.txt ===
## antimicro Gamepad to KB+M event mapper
## Copyright (C) 2015 Travis Nickles <nickles.travis@gmail.com>
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.


# Debian Wheezy has a package for version 2.8.9 so
# that will be the minimum supported version.
cmake_minimum_required(VERSION 2.8.9)
project(antimicro)

if(WIN32)
    # Cause cmake to fail if Qt location is not specified.
    if(NOT CMAKE_PREFIX_PATH)
        message(FATAL_ERROR "Please set CMAKE_PREFIX_PATH to the Qt installation directory. Exiting.")
    endif(NOT CMAKE_PREFIX_PATH)

    # CMP0020: Automatically link Qt executables to qtmain target on Windows.
    cmake_policy(SET CMP0020 NEW)
endif(WIN32)

# The version number.
set(ANTIMICRO_MAJOR_VERSION 2)
set(ANTIMICRO_MINOR_VERSION 23)
set(ANTIMICRO_PATCH_VERSION 0)

option(USE_SDL_2 "Use SDL 2 libraries rather than SDL 1." ON)

if(UNIX)
    option(WITH_X11 "Compile with support for X11." ON)
    option(WITH_UINPUT "Compile with support for uinput. uinput will be usable to simulate events." OFF)
    option(WITH_XTEST "Compile with support for XTest.  XTest will be usable to simulate events." ON)
    option(APPDATA "Build project with AppData file support." OFF)
endif(UNIX)

option(UPDATE_TRANSLATIONS "Call lupdate to update translation files from source." OFF)
option(TRANS_KEEP_OBSOLETE "Do not specify -no-obsolete when calling lupdate." OFF)

if(WIN32)
    option(PORTABLE_PACKAGE "Create portable Windows package" OFF)
    #option(TARGET_ARCH "Choose which version of some libraries to use. (x86, x86_64)" "x86")
    option(WITH_VMULTI "Compile with support for vmulti." OFF)
    option(PERFORM_SIGNING "Sign final executable." OFF)

    if(PORTABLE_PACKAGE)
        message("Portable package mode build")

        add_definitions(-DWIN_PORTABLE_PACKAGE)

        # Only way to force install target to be dependent on createprofiledir.
        add_custom_target(createprofiledir)
        add_custom_command(TARGET createprofiledir PRE_BUILD
            COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_BINARY_DIR}/profiles"
        )
        install(CODE "execute_process(COMMAND ${CMAKE_BUILD_TOOL} createprofiledir WORKING_DIRECTORY \"${CMAKE_CURRENT_BINARY_DIR}\")")
        install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/profiles" DESTINATION ${CMAKE_INSTALL_PREFIX})
    endif(PORTABLE_PACKAGE)

    # Find target architecture based on the compiler.
    if (CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(TARGET_ARCH "x86_64")
    else()
        set(TARGET_ARCH "x86")
    endif(CMAKE_SIZEOF_VOID_P EQUAL 8)

    #if(TARGET_ARCH)
    #    set(ARCH_OPTIONS "x86" "x86_64")
    #    list(FIND ARCH_OPTIONS ${TARGET_ARCH} ARCH_INDEX)
    #    if(ARCH_INDEX EQUAL -1)
    #        message(FATAL_ERROR "No valid architecture choice used. Exiting.")
    #    endif(ARCH_INDEX EQUAL -1)
    #endif(TARGET_ARCH)

    if(WITH_VMULTI)
        add_definitions(-DWITH_VMULTI)
    endif(WITH_VMULTI)
endif(WIN32)

# Use pkg-config to find SDL library.
if(UNIX)
    find_package(PkgConfig REQUIRED)
    #include(FindPkgConfig)

    if(USE_SDL_2)
        pkg_check_modules(SDL2 REQUIRED sdl2)
    elseif(NOT USE_SDL_2)
        pkg_check_modules(SDL REQUIRED sdl)
    endif(USE_SDL_2)

    if(WITH_X11)
        find_package(X11 REQUIRED)
    endif(WITH_X11)

    if(WITH_XTEST AND NOT WITH_X11)
        set(WITH_XTEST OFF)
        message("Cannot use XTest without X11. Disabling XTest support.")
    endif(WITH_XTEST AND NOT WITH_X11)

    if(WITH_XTEST)
        message("XTest support allowed for simulating events.")
    endif(WITH_XTEST)

    if(WITH_UINPUT)
        message("uinput support allowed for simulating events.")
    endif(WITH_UINPUT)

    if(NOT WITH_XTEST AND NOT WITH_UINPUT)
        message(FATAL_ERROR "No system is defined for simulating events.")
    endif(NOT WITH_XTEST AND NOT WITH_UINPUT)
endif(UNIX)

set(antimicro_SOURCES src/main.cpp
    src/mainwindow.cpp
    src/joybuttonwidget.cpp
    src/joystick.cpp
    src/joybutton.cpp
    src/joybuttontypes/joygradientbutton.cpp
    src/event.cpp
    src/inputdaemon.cpp
    src/joyaxis.cpp
    src/joyaxiswidget.cpp
    src/joydpad.cpp
    src/joybuttontypes/joydpadbutton.cpp
    src/axiseditdialog.cpp
    src/xmlconfigreader.cpp
    src/xmlconfigwriter.cpp
    src/joytabwidget.cpp
    src/axisvaluebox.cpp
    src/advancebuttondialog.cpp
    src/simplekeygrabberbutton.cpp
    src/joybuttonslot.cpp
    src/joybuttontypes/joyaxisbutton.cpp
    src/aboutdialog.cpp
    src/setjoystick.cpp
    src/sdleventreader.cpp
    src/setaxisthrottledialog.cpp
    src/keyboard/virtualkeypushbutton.cpp
    src/keyboard/virtualkeyboardmousewidget.cpp
    src/keyboard/virtualmousepushbutton.cpp
    src/buttoneditdialog.cpp
    src/commandlineutility.cpp
    src/joycontrolstick.cpp
    src/joybuttontypes/joycontrolstickbutton.cpp
    src/joybuttontypes/joycontrolstickmodifierbutton.cpp
    src/joycontrolstickeditdialog.cpp
    src/joycontrolstickpushbutton.cpp
    src/joycontrolstickbuttonpushbutton.cpp
    src/joycontrolstickstatusbox.cpp
    src/advancestickassignmentdialog.cpp
    src/dpadpushbutton.cpp
    src/dpadeditdialog.cpp
    src/vdpad.cpp
    src/joydpadbuttonwidget.cpp
    src/quicksetdialog.cpp
    src/mousehelper.cpp
    src/mousesettingsdialog.cpp
    src/mousedialog/mousecontrolsticksettingsdialog.cpp
    src/mousedialog/mouseaxissettingsdialog.cpp
    src/mousedialog/mousebuttonsettingsdialog.cpp
    src/mousedialog/mousedpadsettingsdialog.cpp
    src/joytabwidgetcontainer.cpp
    src/mousedialog/springmoderegionpreview.cpp
    src/joystickstatuswindow.cpp
    src/joybuttonstatusbox.cpp
    src/qtkeymapperbase.cpp
    src/flashbuttonwidget.cpp
    src/xmlconfigmigration.cpp
    src/qkeydisplaydialog.cpp
    src/antkeymapper.cpp
    src/inputdevice.cpp
    src/mainsettingsdialog.cpp
    src/gamecontroller/gamecontrollertriggerbutton.cpp
    src/setnamesdialog.cpp
    src/autoprofileinfo.cpp
    src/addeditautoprofiledialog.cpp
    src/editalldefaultautoprofiledialog.cpp
    src/common.cpp
    src/localantimicroserver.cpp
    src/extraprofilesettingsdialog.cpp
    src/antimicrosettings.cpp
    src/joybuttoncontextmenu.cpp
    src/joycontrolstickcontextmenu.cpp
    src/dpadcontextmenu.cpp
    src/joyaxiscontextmenu.cpp
    src/stickpushbuttongroup.cpp
    src/dpadpushbuttongroup.cpp
    src/joybuttonmousehelper.cpp
    src/logger.cpp
    src/inputdevicebitarraystatus.cpp
    src/applaunchhelper.cpp
    src/slotitemlistwidget.cpp
    src/eventhandlers/baseeventhandler.cpp
    src/eventhandlerfactory.cpp
    src/uihelpers/advancebuttondialoghelper.cpp
    src/uihelpers/buttoneditdialoghelper.cpp
    src/uihelpers/joytabwidgethelper.cpp
    src/uihelpers/joyaxiscontextmenuhelper.cpp
    src/uihelpers/joycontrolstickcontextmenuhelper.cpp
    src/uihelpers/dpadcontextmenuhelper.cpp
    src/uihelpers/dpadeditdialoghelper.cpp
    src/uihelpers/joycontrolstickeditdialoghelper.cpp
    src/uihelpers/gamecontrollermappingdialoghelper.cpp
    src/mousedialog/uihelpers/mouseaxissettingsdialoghelper.cpp
    src/mousedialog/uihelpers/mousebuttonsettingsdialoghelper.cpp
    src/mousedialog/uihelpers/mousecontrolsticksettingsdialoghelper.cpp
    src/mousedialog/uihelpers/mousedpadsettingsdialoghelper.cpp
)

set(antimicro_HEADERS src/mainwindow.h
    src/joybuttonwidget.h
    src/joystick.h
    src/joybutton.h
    src/joybuttontypes/joygradientbutton.h
    src/inputdaemon.h
    src/joyaxis.h
    src/joyaxiswidget.h
    src/joydpad.h
    src/joybuttontypes/joydpadbutton.h
    src/axiseditdialog.h
    src/xmlconfigreader.h
    src/xmlconfigwriter.h
    src/joytabwidget.h
    src/axisvaluebox.h
    src/advancebuttondialog.h
    src/simplekeygrabberbutton.h
    src/joybuttonslot.h
    src/joybuttontypes/joyaxisbutton.h
    src/aboutdialog.h
    src/setjoystick.h
    src/sdleventreader.h
    src/setaxisthrottledialog.h
    src/keyboard/virtualkeypushbutton.h
    src/keyboard/virtualkeyboardmousewidget.h
    src/keyboard/virtualmousepushbutton.h
    src/buttoneditdialog.h
    src/commandlineutility.h
    src/joycontrolstick.h
    src/joybuttontypes/joycontrolstickbutton.h
    src/joybuttontypes/joycontrolstickmodifierbutton.h
    src/joycontrolstickeditdialog.h
    src/joycontrolstickpushbutton.h
    src/joycontrolstickbuttonpushbutton.h
    src/joycontrolstickstatusbox.h
    src/advancestickassignmentdialog.h
    src/dpadpushbutton.h
    src/dpadeditdialog.h
    src/vdpad.h
    src/joydpadbuttonwidget.h
    src/quicksetdialog.h
    src/mousehelper.h
    src/mousesettingsdialog.h
    src/mousedialog/mousecontrolsticksettingsdialog.h
    src/mousedialog/mouseaxissettingsdialog.h
    src/mousedialog/mousebuttonsettingsdialog.h
    src/mousedialog/mousedpadsettingsdialog.h
    src/joytabwidgetcontainer.h
    src/mousedialog/springmoderegionpreview.h
    src/joystickstatuswindow.h
    src/joybuttonstatusbox.h
    src/qtkeymapperbase.h
    src/flashbuttonwidget.h
    src/xmlconfigmigration.h
    src/qkeydisplaydialog.h
    src/antkeymapper.h
    src/inputdevice.h
    src/mainsettingsdialog.h
    src/gamecontroller/gamecontrollertriggerbutton.h
    src/setnamesdialog.h
    src/autoprofileinfo.h
    src/addeditautoprofiledialog.h
    src/editalldefaultautoprofiledialog.h
    src/localantimicroserver.h
    src/extraprofilesettingsdialog.h
    src/antimicrosettings.h
    src/joybuttoncontextmenu.h
    src/joycontrolstickcontextmenu.h
    src/dpadcontextmenu.h
    src/joyaxiscontextmenu.h
    src/stickpushbuttongroup.h
    src/dpadpushbuttongroup.h
    src/joybuttonmousehelper.h
    src/logger.h
    src/inputdevicebitarraystatus.h
    src/applaunchhelper.h
    src/slotitemlistwidget.h
    src/eventhandlers/baseeventhandler.h
    src/eventhandlerfactory.h
    src/uihelpers/advancebuttondialoghelper.h
    src/uihelpers/buttoneditdialoghelper.h
    src/uihelpers/joytabwidgethelper.h
    src/uihelpers/joyaxiscontextmenuhelper.h
    src/uihelpers/joycontrolstickcontextmenuhelper.h
    src/uihelpers/dpadcontextmenuhelper.h
    src/uihelpers/dpadeditdialoghelper.h
    src/uihelpers/joycontrolstickeditdialoghelper.h
    src/uihelpers/gamecontrollermappingdialoghelper.h
    src/mousedialog/uihelpers/mouseaxissettingsdialoghelper.h
    src/mousedialog/uihelpers/mousebuttonsettingsdialoghelper.h
    src/mousedialog/uihelpers/mousecontrolsticksettingsdialoghelper.h
    src/mousedialog/uihelpers/mousedpadsettingsdialoghelper.h
)

set(antimicro_FORMS src/mainwindow.ui
    src/axiseditdialog.ui
    src/advancebuttondialog.ui
    src/aboutdialog.ui
    src/setaxisthrottledialog.ui
    src/buttoneditdialog.ui
    src/joycontrolstickeditdialog.ui
    src/advancestickassignmentdialog.ui
    src/dpadeditdialog.ui
    src/quicksetdialog.ui
    src/mousesettingsdialog.ui
    src/joystickstatuswindow.ui
    src/qkeydisplaydialog.ui
    src/gamecontrollermappingdialog.ui
    src/mainsettingsdialog.ui
    src/setnamesdialog.ui
    src/addeditautoprofiledialog.ui
    src/editalldefaultautoprofiledialog.ui
    src/extraprofilesettingsdialog.ui
    src/capturedwindowinfodialog.ui
)

set(antimicro_RESOURCES src/resources.qrc)

# Files that require SDL 2 support.
if(USE_SDL_2)
    LIST(APPEND antimicro_SOURCES src/gamecontroller/gamecontroller.cpp
         src/gamecontroller/gamecontrollerdpad.cpp
         src/gamecontroller/gamecontrollerset.cpp
         src/gamecontroller/gamecontrollertrigger.cpp

=== other/CMakeLists.txt ===
add_subdirectory(appdata)

add_custom_target(manpage)
add_custom_command(TARGET manpage PRE_BUILD
    COMMAND gzip -c "${PROJECT_SOURCE_DIR}/other/antimicro.1" > "antimicro.1.gz" VERBATIM
)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/antimicro.1.gz" DESTINATION "share/man/man1")

=== other/appdata/CMakeLists.txt ===
# Make appdata optional when installing an application.
if(APPDATA)
    add_custom_target(appdata)
    
    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/PO_files/")

    add_custom_command(TARGET appdata PRE_BUILD
        # Add an entry per language
        COMMAND msgfmt "${PROJECT_SOURCE_DIR}/other/appdata/PO_files/en.po" -o "${CMAKE_CURRENT_BINARY_DIR}/PO_files/en.mo"

        COMMAND itstool -i "${PROJECT_SOURCE_DIR}/other/appdata/appdata.its" -j "${PROJECT_SOURCE_DIR}/other/appdata/antimicro.appdata.xml.in" -o "antimicro.appdata.xml" "${CMAKE_CURRENT_BINARY_DIR}/PO_files/*.mo"
    )

    # Only install an appdata file if the user requested to have one built.
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/antimicro.appdata.xml" DESTINATION "share/appdata")
endif(APPDATA)

=== share/antimicro/translations/CMakeLists.txt ===
# This will ensure that the *.qm files will be stored
# in the right place within the build directory.
file(GLOB antimicro_TRANSLATIONS antimicro_*.ts)
list(APPEND antimicro_TRANSLATIONS antimicro.ts)
file(GLOB_RECURSE antimicro_BASE_SOURCES ${PROJECT_SOURCE_DIR}/src/*.cpp)
file(GLOB_RECURSE antimicro_BASE_FORMS ${PROJECT_SOURCE_DIR}/src/*.ui)

if(USE_QT5)
    if(UPDATE_TRANSLATIONS)
#        if(TRANS_KEEP_OBSOLETE)
            QT5_CREATE_TRANSLATION(antimicro_QMFILES ${antimicro_BASE_SOURCES}
                ${antimicro_BASE_FORMS} ${antimicro_TRANSLATIONS})
#	else()
#            QT5_CREATE_TRANSLATION(antimicro_QMFILES ${antimicro_BASE_SOURCES}
#                ${antimicro_BASE_FORMS} ${antimicro_TRANSLATIONS}
#                OPTIONS "-no-obsolete")
#	endif(TRANS_KEEP_OBSOLETE)
    else()
        QT5_ADD_TRANSLATION(antimicro_QMFILES ${antimicro_TRANSLATIONS})
    endif(UPDATE_TRANSLATIONS)
else()
    if(UPDATE_TRANSLATIONS)
#        if(TRANS_KEEP_OBSOLETE)
            QT4_CREATE_TRANSLATION(antimicro_QMFILES ${antimicro_BASE_SOURCES}
                ${antimicro_BASE_FORMS} ${antimicro_TRANSLATIONS})
#	else()
#            QT4_CREATE_TRANSLATION(antimicro_QMFILES ${antimicro_BASE_SOURCES}
#                ${antimicro_BASE_FORMS} ${antimicro_TRANSLATIONS}
#                 OPTIONS "-no-obsolete")
#	endif(TRANS_KEEP_OBSOLETE)
    else()
        QT4_ADD_TRANSLATION(antimicro_QMFILES ${antimicro_TRANSLATIONS})
    endif(UPDATE_TRANSLATIONS)
endif(USE_QT5)

add_custom_target(updateqm DEPENDS ${antimicro_QMFILES})
install(FILES ${antimicro_QMFILES} DESTINATION "share/antimicro/translations")

set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM true)

=== debian/changelog ===
antimicro (2.23-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:09:47 +0100

antimicro (2.23-2) unstable; urgency=medium

  * Bump Policy (with no relevant changes)
  * Enable Linux-specific uinput only building for Linux

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 16 Oct 2019 00:21:54 +0200

antimicro (2.23-1) unstable; urgency=medium

  * Initial packaging (Closes: #752709)

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 03 Jul 2019 18:55:23 +0200

=== debian/control ===
Source: antimicro
Section: utils
Priority: optional
Maintainer: Thorsten Glaser <tg@mirbsd.de>
Homepage: https://github.com/AntiMicro/antimicro
Build-Depends: debhelper-compat (= 12), cmake, gettext, itstool,
 libsdl2-dev, libx11-dev, libxi-dev, libxtst-dev,
 lsb-release, pkg-config, qttools5-dev, qttools5-dev-tools
Standards-Version: 4.4.1
Rules-Requires-Root: no
VCS-git: https://evolvis.org/anonscm/git/alioth/antimicro.git -b master
VCS-Browser: https://evolvis.org/plugins/scmgit/cgi-bin/gitweb.cgi?p=alioth/antimicro.git;a=shortlog;h=refs/heads/master

Package: antimicro
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: evtest, joystick
Description: GUI for mapping keyboard keys and mouse controls to a gamepad
 antimicro is a graphical program used to map keyboard keys and mouse
 controls to a gamepad. This program is useful for playing PC games
 using a gamepad that do not have any form of built-in gamepad support.
 However, you can use this program to control any desktop application
 (while running an X11 environment) with a gamepad.
 .
 https://github.com/AntiMicro/antimicro-profiles is a repository for
 pre-made antimicro profiles, providing convenience controller layouts
 suitable for playing a game without having to map everything yourself.
 .
 Use evtest, or perhaps jstest from the joystick package, if you
 encounter problems detecting a controller, axes or buttons.

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(findstring terse,${DEB_BUILD_OPTIONS}))
export DH_VERBOSE=1
export V=1
export VERBOSE=1
endif

LC_ALL:=C.UTF-8
export LC_ALL

DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS?=$(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

OUR_CPPFLAGS:=
OUR_CFLAGS:=
OUR_CXXFLAGS:=
OUR_LDFLAGS:=	-Wl,--as-needed

# better debugging if requested
ifneq (,$(findstring optdbg,${DEB_BUILD_OPTIONS}))
OUR_CFLAGS+=	-Og
OUR_CXXFLAGS+=	-Og
endif

OUR_CPPFLAGS+=	-I$(shell pwd)/debian/q-include

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND := ${OUR_CPPFLAGS}
export DEB_CFLAGS_MAINT_APPEND := ${OUR_CFLAGS}
export DEB_CXXFLAGS_MAINT_APPEND := ${OUR_CXXFLAGS}
export DEB_LDFLAGS_MAINT_APPEND := ${OUR_LDFLAGS}

%:
	dh $@ --buildsystem=cmake

CMAKE_DEFS:=	-DCMAKE_SKIP_RPATH=ON
CMAKE_DEFS+=	-DUSE_SDL_2=ON
CMAKE_DEFS+=	-DWITH_X11=ON
ifeq (linux,${DEB_HOST_ARCH_OS})
CMAKE_DEFS+=	-DWITH_UINPUT=ON
else
CMAKE_DEFS+=	-DWITH_UINPUT=OFF
endif
CMAKE_DEFS+=	-DWITH_XTEST=ON
CMAKE_DEFS+=	-DAPPDATA=ON
CMAKE_DEFS+=	-DUPDATE_TRANSLATIONS=ON

override_dh_auto_configure:
	rm -rf debian/q-include
	mkdir debian/q-include
	printf '#define DEB_PKG_VERSION "%s (%s %s/%s)"\n' \
	    "$$(dpkg\-parsechangelog | sed -n '/^Version: */{s///p;q;}')" \
	    "$$(lsb_release -si)" \
	    "$$(lsb_release -sc)" \
	    "${DEB_HOST_ARCH}" \
	    >debian/q-include/DEB_PKG_VERSION.h
	exec dh_auto_configure -- ${CMAKE_DEFS}

override_dh_auto_clean:
	rm -rf debian/q-include
	exec dh_auto_clean

=== debian/watch ===
version=4
https://github.com/AntiMicro/antimicro/tags \
 .*/antimicro/archive/(\d+(?:\.\d+)+)\.tar\.gz

## antimicro 3.1.4

=== CMakeLists.txt ===
## antimicrox Gamepad to KB+M event mapper
## Copyright (C) 2015 Travis Nickles <nickles.travis@gmail.com>
## Copyright (C) 2020 Jagoda Górska <juliagoda.pl@protonmail.com>
## Copyright (C) 2020 Paweł Kotiuk <kotiuk@zohomail.eu>
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.


cmake_minimum_required(VERSION 3.6)
set(QT_REQUIRED_VERSION 5.8)
set(SDL_REQUIRED_VERSION 2.0.6)
project(antimicrox)

if(POLICY CMP0071)
    cmake_policy(SET CMP0071 NEW)
endif()

if(UNIX)
    find_package(ECM REQUIRED NO_MODULE)
    set(CMAKE_MODULE_PATH ${ECM_MODULE_DIR})
endif(UNIX)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules" "${CMAKE_ROOT}/Modules")

set(CMAKE_INCLUDE_CURRENT_DIR ON)


if(UNIX AND NOT APPLE AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "force cmake prefix to be set for /usr" FORCE)
endif(UNIX AND NOT APPLE AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

include(CheckCXXCompilerFlag)
include(GNUInstallDirs)

if(UNIX)
    include(ECMInstallIcons)
endif(UNIX)

CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)


if(COMPILER_SUPPORTS_CXX11)
    if(NOT WIN32)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
        #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wall -Wextra -Wcast-align -Wcast-qual -Wctor-dtor-privacy -Wdisabled-optimization -Wformat=2 -Winit-self -Wlogical-op -Wmissing-declarations -Wmissing-include-dirs -Wnoexcept -Wold-style-cast -Woverloaded-virtual -Wredundant-decls -Wstrict-null-sentinel -Wstrict-overflow=5 -Wundef -Wno-unused -std=c++11")
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    endif()
else()
    message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
endif(COMPILER_SUPPORTS_CXX11)

# The version number.
set(ANTIMICROX_MAJOR_VERSION 3)
set(ANTIMICROX_MINOR_VERSION 1)
set(ANTIMICROX_PATCH_VERSION 4)

option(WITH_TESTS "Allow tests for classes" OFF)

if(WITH_TESTS)
    message("Tests enabled")
endif(WITH_TESTS)

if(UNIX)
    option(WITH_X11 "Compile with support for X11." ON)
    option(WITH_UINPUT "Compile with support for uinput. uinput will be usable to simulate events." ON)
    option(WITH_XTEST "Compile with support for XTest.  XTest will be usable to simulate events." ON)
    option(APPDATA "Build project with AppData file support." ON)
endif(UNIX)

option(UPDATE_TRANSLATIONS "Call lupdate to update translation files from source." OFF)
option(TRANS_KEEP_OBSOLETE "Add -noobsolete option to lupdate command to get rid of old text entries" OFF)
option(ATTACH_FAKE_CLASSES "Fake classes can be used in application to tests functionalities" OFF)


if(UNIX)
    find_package(PkgConfig REQUIRED)

    pkg_check_modules(SDL2 REQUIRED sdl2)
#    find_package(SDL2 REQUIRED) -> will fail on some systems

    if(WITH_X11)
        find_package(X11 REQUIRED)
    endif(WITH_X11)

    if(WITH_XTEST AND NOT WITH_X11)
        set(WITH_XTEST OFF)
        message("Cannot use XTest without X11. Disabling XTest support.")
    endif(WITH_XTEST AND NOT WITH_X11)

    if(WITH_XTEST)
        message("XTest support allowed for simulating events.")
    endif(WITH_XTEST)

    if(WITH_UINPUT)
        message("uinput support allowed for simulating events.")
    endif(WITH_UINPUT)

    if(NOT WITH_XTEST AND NOT WITH_UINPUT)
        message(FATAL_ERROR "No system is defined for simulating events.")
    endif(NOT WITH_XTEST AND NOT WITH_UINPUT)
endif(UNIX)

set(antimicrox_MAIN src/main.cpp)

set(antimicrox_SOURCES
        src/aboutdialog.cpp
        src/addeditautoprofiledialog.cpp
        src/advancebuttondialog.cpp
        src/advancestickassignmentdialog.cpp
        src/antimicrosettings.cpp
        src/antkeymapper.cpp
        src/applaunchhelper.cpp
        src/autoprofileinfo.cpp
        src/axiseditdialog.cpp
        src/axisvaluebox.cpp
        src/buttoneditdialog.cpp
        src/calibration.cpp
        src/commandlineutility.cpp
        src/common.cpp
        src/dpadcontextmenu.cpp
        src/dpadeditdialog.cpp
        src/dpadpushbutton.cpp
        src/dpadpushbuttongroup.cpp
        src/editalldefaultautoprofiledialog.cpp
        src/event.cpp
        src/eventhandlerfactory.cpp
        src/eventhandlers/baseeventhandler.cpp
        src/extraprofilesettingsdialog.cpp
        src/flashbuttonwidget.cpp
        src/gamecontroller/gamecontroller.cpp
        src/gamecontroller/gamecontrollerdpad.cpp
        src/gamecontroller/gamecontrollerset.cpp
        src/gamecontroller/gamecontrollertrigger.cpp
        src/gamecontroller/gamecontrollertriggerbutton.cpp
        src/gamecontroller/xml/gamecontrollerdpadxml.cpp
        src/gamecontroller/xml/gamecontrollertriggerxml.cpp
        src/gamecontroller/xml/gamecontrollerxml.cpp
        src/gamecontrollerexample.cpp
        src/gamecontrollermappingdialog.cpp
        src/globalvariables.cpp
        src/inputdaemon.cpp
        src/inputdevice.cpp
        src/inputdevicebitarraystatus.cpp
        src/joyaxis.cpp
        src/joyaxiscontextmenu.cpp
        src/joyaxiswidget.cpp
        src/joybutton.cpp
        src/joybuttoncontextmenu.cpp
        src/joybuttonmousehelper.cpp
        src/joybuttonslot.cpp
        src/joybuttonstatusbox.cpp
        src/joybuttontypes/joyaxisbutton.cpp
        src/joybuttontypes/joycontrolstickbutton.cpp
        src/joybuttontypes/joycontrolstickmodifierbutton.cpp
        src/joybuttontypes/joydpadbutton.cpp
        src/joybuttontypes/joygradientbutton.cpp
        src/joybuttonwidget.cpp
        src/joycontrolstick.cpp
        src/joycontrolstickbuttonpushbutton.cpp
        src/joycontrolstickcontextmenu.cpp
        src/joycontrolstickeditdialog.cpp
        src/joycontrolstickpushbutton.cpp
        src/joycontrolstickstatusbox.cpp
        src/joydpad.cpp
        src/joydpadbuttonwidget.cpp
        src/joystick.cpp
        src/joystickstatuswindow.cpp
        src/joytabwidget.cpp
        src/joytabwidgetcontainer.cpp
        src/keyboard/virtualkeyboardmousewidget.cpp
        src/keyboard/virtualkeypushbutton.cpp
        src/keyboard/virtualmousepushbutton.cpp
        src/localantimicroserver.cpp
        src/logger.cpp
        src/mainsettingsdialog.cpp
        src/mainwindow.cpp
        src/messagehandler.cpp
        src/mousedialog/mouseaxissettingsdialog.cpp
        src/mousedialog/mousebuttonsettingsdialog.cpp
        src/mousedialog/mousecontrolsticksettingsdialog.cpp
        src/mousedialog/mousedpadsettingsdialog.cpp
        src/mousedialog/springmoderegionpreview.cpp
        src/mousedialog/uihelpers/mouseaxissettingsdialoghelper.cpp
        src/mousedialog/uihelpers/mousebuttonsettingsdialoghelper.cpp
        src/mousedialog/uihelpers/mousecontrolsticksettingsdialoghelper.cpp
        src/mousedialog/uihelpers/mousedpadsettingsdialoghelper.cpp
        src/mousehelper.cpp
        src/mousesettingsdialog.cpp
        src/qkeydisplaydialog.cpp
        src/qtkeymapperbase.cpp
        src/quicksetdialog.cpp
        src/sdleventreader.cpp
        src/setaxisthrottledialog.cpp
        src/setjoystick.cpp
        src/setnamesdialog.cpp
        src/simplekeygrabberbutton.cpp
        src/slotitemlistwidget.cpp
        src/stickpushbuttongroup.cpp
        src/uihelpers/advancebuttondialoghelper.cpp
        src/uihelpers/buttoneditdialoghelper.cpp
        src/uihelpers/dpadcontextmenuhelper.cpp
        src/uihelpers/dpadeditdialoghelper.cpp
        src/uihelpers/gamecontrollermappingdialoghelper.cpp
        src/uihelpers/joyaxiscontextmenuhelper.cpp
        src/uihelpers/joycontrolstickcontextmenuhelper.cpp
        src/uihelpers/joycontrolstickeditdialoghelper.cpp
        src/uihelpers/joytabwidgethelper.cpp
        src/vdpad.cpp
        src/xml/inputdevicexml.cpp
        src/xml/joyaxisxml.cpp
        src/xml/joybuttonslotxml.cpp
        src/xml/joybuttonxml.cpp
        src/xml/joydpadxml.cpp
        src/xml/setjoystickxml.cpp
        src/xmlconfigmigration.cpp
        src/xmlconfigreader.cpp
        src/xmlconfigwriter.cpp
        )

set(antimicrox_HEADERS
        src/aboutdialog.h
        src/addeditautoprofiledialog.h
        src/advancebuttondialog.h
        src/advancestickassignmentdialog.h
        src/antimicrosettings.h
        src/antkeymapper.h
        src/applaunchhelper.h
        src/autoprofileinfo.h
        src/axiseditdialog.h
        src/axisvaluebox.h
        src/buttoneditdialog.h
        src/calibration.h
        src/commandlineutility.h
        src/dpadcontextmenu.h
        src/dpadeditdialog.h
        src/dpadpushbutton.h
        src/dpadpushbuttongroup.h
        src/editalldefaultautoprofiledialog.h
        src/eventhandlerfactory.h
        src/eventhandlers/baseeventhandler.h
        src/extraprofilesettingsdialog.h
        src/flashbuttonwidget.h
        src/gamecontroller/gamecontroller.h
        src/gamecontroller/gamecontrollerdpad.h
        src/gamecontroller/gamecontrollerset.h
        src/gamecontroller/gamecontrollertrigger.h
        src/gamecontroller/gamecontrollertriggerbutton.h
        src/gamecontroller/xml/gamecontrollerdpadxml.h
        src/gamecontroller/xml/gamecontrollertriggerxml.h
        src/gamecontroller/xml/gamecontrollerxml.h
        src/gamecontrollerexample.h
        src/gamecontrollermappingdialog.h
        src/globalvariables.h
        src/inputdaemon.h
        src/inputdevice.h
        src/inputdevicebitarraystatus.h
        src/joyaxis.h
        src/joyaxiscontextmenu.h
        src/joyaxiswidget.h
        src/joybutton.h
        src/joybuttoncontextmenu.h
        src/joybuttonmousehelper.h
        src/joybuttonslot.h
        src/joybuttonstatusbox.h
        src/joybuttontypes/joyaxisbutton.h
        src/joybuttontypes/joycontrolstickbutton.h
        src/joybuttontypes/joycontrolstickmodifierbutton.h
        src/joybuttontypes/joydpadbutton.h
        src/joybuttontypes/joygradientbutton.h
        src/joybuttonwidget.h
        src/joycontrolstick.h
        src/joycontrolstickbuttonpushbutton.h
        src/joycontrolstickcontextmenu.h
        src/joycontrolstickeditdialog.h
        src/joycontrolstickpushbutton.h
        src/joycontrolstickstatusbox.h
        src/joydpad.h
        src/joydpadbuttonwidget.h
        src/joystick.h
        src/joystickstatuswindow.h
        src/joytabwidget.h
        src/joytabwidgetcontainer.h
        src/keyboard/virtualkeyboardmousewidget.h
        src/keyboard/virtualkeypushbutton.h
        src/keyboard/virtualmousepushbutton.h
        src/localantimicroserver.h
        src/logger.h
        src/mainsettingsdialog.h
        src/mainwindow.h
        src/messagehandler.h
        src/mousedialog/mouseaxissettingsdialog.h
        src/mousedialog/mousebuttonsettingsdialog.h
        src/mousedialog/mousecontrolsticksettingsdialog.h
        src/mousedialog/mousedpadsettingsdialog.h
        src/mousedialog/springmoderegionpreview.h
        src/mousedialog/uihelpers/mouseaxissettingsdialoghelper.h
        src/mousedialog/uihelpers/mousebuttonsettingsdialoghelper.h
        src/mousedialog/uihelpers/mousecontrolsticksettingsdialoghelper.h
        src/mousedialog/uihelpers/mousedpadsettingsdialoghelper.h
        src/mousehelper.h
        src/mousesettingsdialog.h
        src/qkeydisplaydialog.h
        src/qtkeymapperbase.h
        src/quicksetdialog.h
        src/sdleventreader.h
        src/setaxisthrottledialog.h

=== other/CMakeLists.txt ===
add_subdirectory(appdata)

add_custom_target(manpage)
add_custom_command(TARGET manpage PRE_BUILD
        COMMAND gzip -c -9 -n "${PROJECT_SOURCE_DIR}/other/antimicrox.1" > "antimicrox.1.gz" VERBATIM
        )
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/antimicrox.1.gz" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/man/man1")

=== share/antimicrox/translations/CMakeLists.txt ===
# This will ensure that the *.qm files will be stored
# in the right place within the build directory.
file(GLOB antimicrox_TRANSLATIONS antimicrox_*.ts)
list(APPEND antimicrox_TRANSLATIONS antimicrox.ts)
file(GLOB_RECURSE antimicrox_BASE_SOURCES ${PROJECT_SOURCE_DIR}/src/*.cpp)
file(GLOB_RECURSE antimicrox_BASE_FORMS ${PROJECT_SOURCE_DIR}/src/*.ui)


if(UPDATE_TRANSLATIONS)
    message("Update translations - lupdate ON")
    if(TRANS_KEEP_OBSOLETE)
        message("getting rid of old text entries: \"lupdate -noobsolete\" ON")
        QT5_CREATE_TRANSLATION(antimicrox_QMFILES ${antimicrox_BASE_SOURCES}
                ${antimicrox_BASE_FORMS} ${antimicrox_TRANSLATIONS} OPTIONS -Inobsolete)
    else()
        QT5_CREATE_TRANSLATION(antimicrox_QMFILES ${antimicrox_BASE_SOURCES}
                ${antimicrox_BASE_FORMS} ${antimicrox_TRANSLATIONS})
    endif(TRANS_KEEP_OBSOLETE)
else()
    QT5_ADD_TRANSLATION(antimicrox_QMFILES ${antimicrox_TRANSLATIONS})
endif(UPDATE_TRANSLATIONS)


add_custom_target(updateqm DEPENDS ${antimicrox_QMFILES})
install(FILES ${antimicrox_QMFILES} DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/antimicrox/translations")

set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM true)

=== debian/changelog ===
antimicro (3.1.4-2) unstable; urgency=low

  * QA upload.
  * Update d/watch to GitHub’s latest changes
  * d/p/work-around-Linux-API-break.diff: new, Closes: #1067624
  * Update Maintainer as orphaned

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 24 Mar 2024 20:57:06 +0100

antimicro (3.1.4-1) unstable; urgency=low

  * Package maintained fork AntiMicroX
  * Conflict with the upstream-provided .deb-format binary package
  * Modernise packaging
  * Update lintian overrides and apply lintian-provided spelling fixes
  * Fix a bit, forwarding all patches

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 01 Feb 2021 04:24:42 +0100

=== debian/control ===
Source: antimicro
Section: utils
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Homepage: https://github.com/AntiMicroX/antimicrox
Build-Depends: debhelper-compat (= 13), cmake, extra-cmake-modules,
 gettext, itstool,
 libsdl2-dev, libx11-dev, libxi-dev, libxtst-dev,
 lsb-release, pkg-config, qttools5-dev, qttools5-dev-tools
Standards-Version: 4.5.1
Rules-Requires-Root: no
VCS-git: https://evolvis.org/anonscm/git/alioth/antimicro.git -b master
VCS-Browser: https://evolvis.org/plugins/scmgit/cgi-bin/gitweb.cgi?p=alioth/antimicro.git;a=shortlog;h=refs/heads/master

Package: antimicro
Architecture: any
Provides: antimicrox
Conflicts: antimicrox
Replaces: antimicrox
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: evtest, joystick
Description: GUI for mapping keyboard keys and mouse controls to a gamepad
 AntiMicroX is a graphical program used to map keyboard keys and mouse
 controls to a gamepad. This program is useful for playing PC games
 using a gamepad that do not have any form of built-in gamepad support.
 However, you can use this program to control any desktop application
 (while running an X11 environment) with a gamepad.
 .
 https://github.com/AntiMicroX/antimicrox-profiles is a repository for
 pre-made AntiMicroX profiles, providing convenience controller layouts
 suitable for playing a game without having to map everything yourself.
 .
 Use evtest, or perhaps jstest from the joystick package, if you
 encounter problems detecting a controller, axes or buttons.

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter terse,${DEB_BUILD_OPTIONS}))
export DH_VERBOSE=1
export V=1
export VERBOSE=1
endif

LC_ALL:=C.UTF-8
export LC_ALL

shellescape='$(subst ','\'',$(1))'
shellexport=$(1)=$(call shellescape,${$(1)})

DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS?=$(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
include /usr/share/dpkg/pkg-info.mk

OUR_VSN:=${DEB_VERSION} ($(shell lsb_release -si) $(shell lsb_release -sc)/${DEB_HOST_ARCH})

OUR_CPPFLAGS:=
OUR_CFLAGS:=
OUR_CXXFLAGS:=
OUR_LDFLAGS:=

# branding and avoid -Wdate-time (reproducible builds)
OUR_CPPFLAGS+=	-DANTIMICROX_PKG_VERSION=\"$(call shellescape,${OUR_VSN})\"

# unclutter build log; these are upstream’s to fix
OUR_CFLAGS+=	-Wno-deprecated-declarations
OUR_CXXFLAGS+=	-Wno-deprecated-declarations
OUR_CXXFLAGS+=	-Wno-deprecated-copy

# only needed when backporting to buster and older
#OUR_LDFLAGS+=	-Wl,--as-needed

# better debugging if requested
ifneq (,$(findstring optdbg,${DEB_BUILD_OPTIONS}))
OUR_CFLAGS+=	-Og
OUR_CXXFLAGS+=	-Og
endif

dpkgbuildflagsmkescape=$(subst \,\\\,$(1))
export DEB_BUILD_MAINT_OPTIONS:=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CPPFLAGS})
export DEB_CFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CFLAGS})
export DEB_CXXFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CXXFLAGS})
export DEB_LDFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_LDFLAGS})
include /usr/share/dpkg/buildflags.mk
ifneq (,$(wildcard /usr/share/dpkg/buildtools.mk))
include /usr/share/dpkg/buildtools.mk
endif

%:
	dh $@ --buildsystem=cmake

CMAKE_DEFS:=	-DCMAKE_SKIP_RPATH=ON
CMAKE_DEFS+=	-DUPDATE_TRANSLATIONS=ON
# https://github.com/AntiMicroX/antimicrox/issues/138
CMAKE_DEFS+=	-DWITH_TESTS=OFF
CMAKE_DEFS+=	-DAPPDATA=ON
ifeq (linux,${DEB_HOST_ARCH_OS})
CMAKE_DEFS+=	-DWITH_UINPUT=ON
else
CMAKE_DEFS+=	-DWITH_UINPUT=OFF
endif
CMAKE_DEFS+=	-DWITH_X11=ON
CMAKE_DEFS+=	-DWITH_XTEST=ON

override_dh_auto_configure:
	exec dh_auto_configure -- ${CMAKE_DEFS}

execute_after_dh_auto_install:
	# https://github.com/AntiMicroX/antimicrox/issues/87#issuecomment-770516939
	rm -rf debian/antimicro/usr/include
	# https://github.com/AntiMicroX/antimicrox/issues/87#issuecomment-770515628
	rm -rf debian/antimicro/usr/share/doc/antimicrox
	rm -f debian/antimicro/usr/share/antimicrox/CHANGELOG.md

override_dh_installchangelogs:
	dh_installchangelogs -- CHANGELOG.md
